Summary: GNU libc
Name: glibc
Version: 2.1.2
Release: 4nw3
Copyright: LGPL
Group: System Environment/Libraries
Source0: ftp://sourceware.cygnus.com/pub/glibc/glibc-2.1.2.tar.gz
Source1: ftp://ftp.gwdg.de/pub/linux/glibc/glibc-crypt-2.1.1.tar.gz
Source2: glibc-compat-2.1.2.tar.gz
Source3: glibc-redhat-nsswitch.conf
Source4: ftp://sourceware.cygnus.com/pub/glibc/glibc-linuxthreads-2.1.2.tar.gz
# Red Hat patch to load non-versioned binaries on a versioned system.
Patch0: glibc-redhat-noversion.patch
# Red Hat patch to add extern C to arpa/nameser.h for C++ programs.
Patch1: glibc-redhat-cppfix.patch
# Red Hat keeps certain system files in different locations.
Patch2: glibc-redhat-paths.patch
# Red Hat patch to allow nscd to respond to SIGHUP.
Patch3: glibc-redhat-nscd.patch
# Red Hat patch to add xdr_ypall function.
Patch4: glibc-redhat-xdr_ypall.patch
# Rebel patch to add sys/procfs.h.
Patch5: glibc-rebel-procfs_h.patch
# Rebel patch to add sys/elf.h.
Patch6: glibc-rebel-elf_h.patch
# Rebel patch to add sys/ucontext.h
Patch7: glibc-rebel-ucontext_h.patch
# Rebel patch to add clear cache support after modifying
# the .text segment in shared libraries with DT_TEXTREL set.
Patch8: glibc-rebel-cache.patch
# Rebel patch for miscellaneous FP math fixes.
Patch9: glibc-rebel-fpmath.patch
# Rebel patch to modify sys/user.h to match the ARM kernel.
Patch10: glibc-rebel-arm.patch
# Rebel patch to add threading capabilities to libdb2.
Patch11: glibc-rebel-libdb2.patch
# Rebel patch to add ChangeLog.REBEL
Patch12: glibc-rebel-changelog.patch
Buildroot: /var/tmp/glibc-%{PACKAGE_VERSION}-root
Obsoletes: zoneinfo, libc-static, libc-devel, libc-profile, libc-headers,
Obsoletes:  linuxthreads, gencat, locale
Autoreq: false
%ifarch alpha
Provides: ld.so.2
%else
%endif
%ifarch sparc
Obsoletes: libc
%endif

%description
Contains the standard libraries that are used by multiple programs on
the system. In order to save disk space and memory, as well as to
ease upgrades, common system code is kept in one place and shared between
programs. This package contains the most important sets of shared libraries,
the standard C library and the standard math library. Without these, a
Linux system will not function. It also contains national language (locale)
support and timezone databases.

%package devel
Summary: Additional libraries required to compile
Group: Development/Libraries
Conflicts: texinfo < 3.11
Prereq: /sbin/install-info
Obsoletes: libc-debug, libc-headers, libc-devel, linuxthreads-devel
Obsoletes: glibc-debug
Prereq: kernel-headers
Requires: kernel-headers >= 2.2.1
Autoreq: true

%description devel
To develop programs which use the standard C libraries (which nearly all
programs do), the system needs to have these standard header files and object
files available for creating the executables.

%package profile
Summary: glibc with profiling support
Group: Development/Libraries
Obsoletes: libc-profile
Autoreq: true

%description profile
When programs are being profiled used gprof, they must use these libraries
instrad of the standard C libraries for gprof to be able to profile
them correctly.

%package -n nscd
Summary: Name Service Caching Daemon
Group: System Environment/Daemons
Conflicts: kernel < 2.2.0
Prereq: /sbin/chkconfig
Autoreq: true

%description -n nscd
nscd caches name service lookups; it can dramatically improve performance
with NIS+, and may help with DNS as well.

You cannot use nscd with 2.0 kernels, due to bugs in the kernel-side thread
support. nscd happens to hit these bugs particularly hard.

%prep
%setup -n glibc-2.1.2 -q -a 1 -a 2 -a 4
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
 
%ifarch armv4l
rm -rf glibc-compat
%endif

find . -type f -size 0 -exec rm -f {} \;
find . -name "*.orig" -exec rm -f {} \;

%build
rm -rf build-$RPM_ARCH-linux
mkdir build-$RPM_ARCH-linux ; cd build-$RPM_ARCH-linux
%ifarch i586 i686
BuildFlags="-mpentium -D__USE_STRING_INLINES -fstrict-aliasing"
%endif
%ifarch armv4l
CC=gcc CFLAGS="$BuildFlags -g -O3" ../configure --prefix=/usr \
	--enable-add-ons=crypt,linuxthreads --without-cvs  \
	--disable-versioning
make -r CFLAGS="$BuildFlags -g -O3"
%else
CC=egcs CFLAGS="$BuildFlags -g -O3" ../configure --prefix=/usr \
	--enable-add-ons=yes --without-cvs  \
	%{_target_cpu}-redhat-linux
make -r CFLAGS="$BuildFlags -g -O3" PARALLELMFLAGS=-s
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install_root=$RPM_BUILD_ROOT install -C build-$RPM_ARCH-linux
cd build-$RPM_ARCH-linux && \
    make install_root=$RPM_BUILD_ROOT install-locales -C ../localedata objdir=`pwd` && \
    cd ..

# Remove the files we don't want to distribute
rm -f $RPM_BUILD_ROOT/usr/lib/libNoVersion*

# the man pages for the linuxthreads require special attention
make -C linuxthreads/man
mkdir -p $RPM_BUILD_ROOT/usr/man/man3
install -m 0644 linuxthreads/man/*.3thr $RPM_BUILD_ROOT/usr/man/man3

gzip -9nvf $RPM_BUILD_ROOT/usr/info/libc*

ln -sf libbsd-compat.a $RPM_BUILD_ROOT/usr/lib/libbsd.a

install -m 644 $RPM_SOURCE_DIR/glibc-redhat-nsswitch.conf \
	$RPM_BUILD_ROOT/etc/nsswitch.conf

# This is for ncsd - in glibc 2.1
install -m 644 nscd/nscd.conf $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 nscd/nscd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/nscd

# The database support
mkdir -p $RPM_BUILD_ROOT/var/db
install -m 644 nss/db-Makefile $RPM_BUILD_ROOT/var/db/Makefile

# Strip binaries
strip $RPM_BUILD_ROOT/sbin/* || :
strip $RPM_BUILD_ROOT/usr/bin/* || :
strip $RPM_BUILD_ROOT/usr/sbin/* || :

# BUILD THE FILE LIST
find $RPM_BUILD_ROOT -type f -or -type l | 
	sed -e 's|.*/etc|%config &|' > rpm.filelist.in
for n in /usr/share /usr/include; do 
    find ${RPM_BUILD_ROOT}${n} -type d | \
	grep -v '^/usr/share$' | \
	sed "s/^/%dir /" >> rpm.filelist.in
done

# primary filelist
sed "s|$RPM_BUILD_ROOT||" < rpm.filelist.in | 
	grep -v '/etc/localtime'  | \
	sort > rpm.filelist

grep '/usr/lib/lib.*_p\.a' < rpm.filelist > profile.filelist
egrep "(/usr/include)|(/usr/info)" < rpm.filelist | 
	grep -v /usr/info/dir > devel.filelist

mv rpm.filelist rpm.filelist.full
grep -v '/usr/lib/lib.*_p.a' rpm.filelist.full | 
	egrep -v "(/usr/include)|(/usr/info)" > rpm.filelist

grep '/usr/lib/lib.*\.a' < rpm.filelist >> devel.filelist
grep '/usr/lib/.*\.o' < rpm.filelist >> devel.filelist
grep '/usr/lib/lib.*\.so' < rpm.filelist >> devel.filelist
grep '/usr/man/man' < rpm.filelist >> devel.filelist

mv rpm.filelist rpm.filelist.full
grep -v '/usr/lib/lib.*\.a' < rpm.filelist.full |
	grep -v '/usr/lib/.*\.o' |
	grep -v '/usr/lib/lib.*\.so'|
	grep -v '/usr/man/man' | 
	grep -v 'nscd' > rpm.filelist

# /etc/localtime - we're proud of our timezone
rm -f $RPM_BUILD_ROOT/etc/localtime
# we should copy this instead of symlinking it
# cp -f $RPM_BUILD_ROOT/usr/share/zoneinfo/US/Eastern $RPM_BUILD_ROOT/etc/localtime
ln -sf ../usr/share/zoneinfo/US/Eastern $RPM_BUILD_ROOT/etc/localtime

# the last bit: more documentation
rm -rf documentation
mkdir documentation
cp linuxthreads/ChangeLog  documentation/ChangeLog.threads
cp linuxthreads/Changes documentation/Changes.threads
cp linuxthreads/README documentation/README.threads
cp linuxthreads/FAQ.html documentation/FAQ-threads.html
cp -r linuxthreads/Examples documentation/examples.threads
cp crypt/README documentation/README.crypt
cp db2/README documentation/README.db2
cp db2/mutex/README documentation/README.db2.mutex
cp timezone/README documentation/README.timezone
cp ChangeLog* documentation
gzip -9 documentation/ChangeLog*

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%post devel
/sbin/install-info /usr/info/libc.info.gz /usr/info/dir

%pre devel
# this used to be a link and it is causing nightmares now
if [ -L /usr/include/scsi ] ; then
    rm -f /usr/include/scsi
fi

%preun devel
if [ "$1" = 0 ]; then
    /sbin/install-info --delete /usr/info/libc.info.gz /usr/info/dir
fi

%post -n nscd
/sbin/chkconfig --add nscd

%preun -n nscd
if [ $1 = 0 ] ; then
    /sbin/chkconfig --del nscd
fi

%clean
rm -rf "$RPM_BUILD_ROOT"
rm -f *.filelist*

%files -f rpm.filelist
%defattr(-,root,root)
%config(noreplace) /etc/localtime
%doc README NEWS INSTALL FAQ BUGS NOTES PROJECTS
%doc documentation/* README.template README.libm
%doc login/README.utmpd hesiod/README.hesiod
%dir /var/db

%files -f devel.filelist devel
%defattr(-,root,root)

%files -f profile.filelist profile
%defattr(-,root,root)

%files -n nscd
%defattr(-,root,root)
%config /etc/nscd.conf
/etc/rc.d/init.d/nscd
/usr/sbin/nscd

%changelog
* Tue May 16 2000 Scott Bambrough <scottb@netwinder.org>
- changed release to 4nw3
- added Andrew Mileski's patch to add threading support to libdb2.
- updated patch to add Changelog.REBEL

* Wed Mar 29 2000 Scott Bambrough <scottb@netwinder.org>
- changed release to 4nw2
- renamed patch to add support for non-versioned apps (Red Hat)
- renamed patch to add extern "C" to arpa/nameser.h (Red Hat)
- renamed patch to modify paths files (Red Hat)
- updated patch to modify nscd for SIGHUP (Red Hat)
- renamed patch to add xdr_ypall (Red Hat) 
- new patch to add sysdeps/unix/sysv/linux/arm/sys/procfs.h, fixes install bug
- new patch to add sysdeps/unix/sysv/linux/arm/sys/elf.h, fixes install bug
- new patch to add sysdeps/unix/sysv/linux/arm/sys/ucontext.h
- new patch to clear cache when .text modified in shared libs.
- new patch for miscellaneous FP math fixes.
- new patch for miscellaneous ARM changes.
- new patch to add Changelog.REBEL

* Sat Sep 11 1999 Scott Bambrough <scottb@netwinder.org>
- modified to use tarballs for 2.1.2 release
- changed release to 4nw1
- removed ARM sigcontext patch, already in sources
- removed sparc types patch, already in sources
- added patch to fix user.h, to match changes in ARM Linux 2.1.12.
- added patch to add sysdeps/unix/sysv/linux/arm/sys/elf.h
- added patch to add sysdeps/unix/sysv/linux/arm/sys/procfs.h

* Mon Aug 30 1999 Scott Bambrough <scottb@netwinder.org>
- modified to use tarballs for 2.1.2pre3 release
- changed release to 3nw1
- added sigcontext patch to get to compile on ARM
- removed db make file patch, already in sources
- removed nscd configure patch, already in sources

* Tue Aug 03 1999 Scott Bambrough <scottb@netwinder.org>
- modified to use tarballs for 2.1.2pre2 release
- modified configure and make sections for armv4l
- changed release to 2nw1
- removed backported fclose patch, already in sources

* Mon Jul 26 1999 Cristian Gafton <gafton@redhat.com>
- add sparc patch from jakub
- backported fclose patch from main devel tree

* Mon Jul 12 1999 Cristian Gafton <gafton@redhat.com>
- update for 2.1.2, the stable release of 2.1
- remove the patch that switched vfork with fork in libio/iopoen, as this
  should be handled now by a different patch
- statvfs patch no loger needed
- upgraded glibc-compat to 2.1.2 to address the __setfpucw problem (#3468)
- /etc/localtime is not a sylink anymore (#3816)
- add patch to implement xdr_ypall (#249)
- patch to link db_dump185 against the right db library (libdb1) (#2972)
- patch to fix the libpthread compatibility problem (#3738)
- patch to fix threads on SMP (#3693)
- patch to fix nscd alignment problem on the sparc (#3171)
- fix the bits/string.h header to stop generating compiler warnings.

* Mon Apr 26 1999 Cristian Gafton <gafton@redhat.com>
- alpha patches from Jay Estabrook to support the RX164

* Wed Apr 14 1999 Cristian Gafton <gafton@redhat.com>
- new CVS update - some patches dropped out
- updated obsoletes tag lines
- patch for the ukraine support

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- add patch for libstdc++ 2.7.2 (enable __dup, __pipe and __waitpid)
- linuxthread patch from HJLu
- add patch to make nscd respond to SIGHUP by dumping the cache

* Wed Apr 07 1999 Cristian Gafton <gafton@redhat.com>
- updated from cvs tree
- add patch for fstatvfs from HJLu

* Thu Apr 01 1999 Cristian Gafton <gafton@redhat.com>
- opentty fix
- don't call lddlibc4 on sparcs

* Thu Mar 25 1999 Cristian Gafton <gafton@redhat.com>
- version 2.1.1
- make nscd run by default at init
- nscd subpackage
- let the subpackages autoreq their own thing

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- version 2.1
- strip binaries installed by default

* Thu Feb 18 1999 Cristian Gafton <gafton@redhat.com>
- updated snapshot
- glibc-crypt might have export problems (who knows?), so we are nosource
  iit for now

* Wed Feb 03 1999 Cristian Gafton <gafton@redhat.com>
- version 2.0.112
- merge glibc-debug into glibc-devel
- new compat add-on

* Wed Jan 13 1999 Cristian Gafton <gafton@redhat.com>
- new glibc-crypt add-on
- version 2.0.109
- handle /etc/localtime separately
- don't include /usr/share in the file list
- don not build glibc-compat on the arm

* Wed Dec 02 1998 Cristian Gafton <gafton@redhat.com>
- build ver 2.0.105 on all four arches
- enabled /usr/include/scsi as part of the glibc package

* Fri Oct 02 1998 Cristian Gafton <gafton@redhat.com>
- first build for 2.0.96
